//************************************************
// Test_Backward.c  --- (c) 06/2018 SSS
//************************************************
// Tutorial XFT35-05: Hardware implementation of
// fuzzy controllers with xfsg
//************************************************

#include "xparameters.h"
#include "xil_cache.h"
#include "backward_ip.h"

// Define delay length
#define DELAY 10
#define BACKWARD_IP_DEVICE_ID                  XPAR_BACKWARD_IP_0_DEVICE_ID

backward_ip backward_ip_Ps;

int main(){

	int x, phi, y, bw, alpha;
	int i, i1, i2, np;
	double inc;
	int Status;

	np = 40;
	inc = 1023./np;
	
	// initialize the software driver
	Status = backward_ip_Initialize(&backward_ip_Ps, BACKWARD_IP_DEVICE_ID);
			if (Status != XST_SUCCESS) {
				xil_printf("Initialization Failure\n\r");
				return XST_FAILURE;
			}

	//xil_printf("Starting...\r\n");
	
	y = 512;
	for (i1=0; i1<=np; i1+=1){
		x = i1*inc;
		for (i2=0; i2<=np; i2+=1){
			phi = i2* inc;
			// write input values to AXI registers
			backward_ip_x_write(&backward_ip_Ps, x);
			backward_ip_y_write(&backward_ip_Ps, y);
			backward_ip_phi_write(&backward_ip_Ps, phi);
			// Wait for completing the inference process
			for (i=0; i<DELAY; i++);
			// read output data from AXI registers
			bw = backward_ip_bw_read(&backward_ip_Ps);
			alpha = backward_ip_alpha_read(&backward_ip_Ps);
			// Print values of x, phi, y, bw, alpha to standard output
			xil_printf("%d\t%d\t%d\t%d\t%d\n\r", x, phi, y, bw, alpha);
		}
		xil_printf("\n\r");
	}

	//xil_printf("\n\rfinished!....\n\r");

    Xil_ICacheDisable();
    Xil_DCacheDisable();

    return 0;
}


